
require '/opt/TARWISServer/UBERN_TESTBED_IMPLEMENTATION/utils.rb';
require 'soap/rpc/standaloneServer'  
require 'soap/wsdlDriver'
require 'soap/rpc/driver'
require 'rexml/document'
require 'xsd/qname'
require 'soap/marshal'
require 'xsd/mapping'
require 'test/unit'
require 'soap/rpc/driver'
require 'webrick'
require 'webrick/httpproxy'
require 'logger'
require 'socket'


class SessionManagementService < SOAP::RPC::StandaloneServer  

  def initialize(* args)  
      super  
      add_method(self, 'getNetwork') 
      add_servant(self, "urn:CommonTypes"); 
      @config = parse_config("/etc/TARWIS.conf");
      print "session_management_service started! at " + @port.to_s + "\n";
      @wiseml_file = get_file_as_string(@config["TARWIS_DIRECTORY"].strip + "UBERN_TESTBED_IMPLEMENTATION/UBERN_TESTBED.wiseml");
  end
  
  def getHostFromMyURL() 
      host = (@config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[0];
      return host
  end
  
  def getPortFromMyURL() 
      port = (@config["SESSION_MANAGEMENT_SERVICE_URL"].split('/')[2]).split(':')[1];
      return port
  end
  
  def getNetwork()     
    return @wiseml_file;
  end
 
end  
