<?php
include '../include/header_observIndex.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
include '../include/functions.php';

$quick_encrypt_password = $config['MYSQL_DATABASE_PASSWORD'];
    
//$encrypted = quick_encrypt("to encrypt string", $quick_encrypt_password);
//$decrypted = quick_decrypt($encrypted, $quick_encrypt_password);
 
?>
</div>

<div id='expObservPageContent' class='pageContent'> 
<?php
    require_once('../include/configurations.php');
    require_once('../include/classes.inc.php');
    require_once("../include/functions.php");
    require_once('../include/snSOAPCom.php');
    require_once('../include/RSService/RSService.php');
    
    //delete old graph files
    delfile("*.svg");
    delfile("*.dot");
    delfile("*.png");
    
    $isTestbedMaintainer = 0;
    if(checkAccessRights($_SERVER['personUniqueID'], "maintainReservation") || checkAccessRights($_SERVER['personUniqueID'], "maintainTestbed")) {
       $isTestbedMaintainer = 1;
    }
    
    $display_id = 0;
    
    if(!empty($_GET['display_id'])){
        $display_id = quick_decrypt($_GET['display_id'], $quick_encrypt_password);
        //echo "<p>display id: " . $_GET['display_id'] . "</p>";
        //echo "<p>calculating display id: " . $display_id . "</p>";
    }

    
    if(!empty($_POST['endExperiment']))
    {
        echo "<table border='0'>";
        echo "<tr><td width='1pt'></td><td><strong>... ended Experiment with ID: " . $_POST['expid'] . " ... saving Results to DB! Please wait!</strong></td></tr>";
        echo "</table>\n";
        Db::getInstance()->selectDB("wsn_info");
        Db::getInstance()->setExperimentDone($_POST['expid']);
        // this causes the site to be refreshed!
        echo "<div id='no_running_experiment'></div>";
        $_POST["endExperiment"] = "";
        $_POST["expid"] = "";
        echo "</div>\n";
        echo "</body>\n";
        echo "</html>\n";
        exit;
    }
   
?> 
<div id='expObservInfoBox' class='infoBox'>
<div id='expObservInfoText' class='infoText'>
<?php

$experimentObjects = getAccessibleExperimentsAsObjects($_SERVER['personUniqueID'], $isTestbedMaintainer);
if(count($experimentObjects) > 0) {
    echo "<br/>\n";
    echo "<strong><font size='3'>Experiments currently running on the Testbed:</font></strong>\n";
    echo "<br/>\n";
    echo "<br/>\n";
    foreach ($experimentObjects as $exp) {
        displaySmallExperimentBox($exp, $quick_encrypt_password);
    }
}

Db::getInstance()->selectDB("wsn_info");
$experiments = Db::getInstance()->getCurrentRunningExperimentIDs();

//echo "<pre>";
//print_r($experiments);
//echo "</pre>";
  
if(!empty($_GET['display_id']) && in_array($display_id,$experiments)) {
    $exp = new CurrExperiment($display_id);
    //echo "<p>first clause " . $display_id . "</p>";
}

// if there's an experiment running, try to display it
elseif(count($experiments) > 0) {
    //echo "<p>else if clause " . $display_id . "</p>";
    $experiments = Db::getInstance()->getCurrentRunningExperimentIDsOfUser($_SERVER['personUniqueID'], $isTestbedMaintainer);        
    if(count($experiments) > 0) {
        if(empty($display_id) || !in_array($display_id,$experiments) ) {
            $exp = new CurrExperiment($experiments[0]);
        }
        else {
           $exp = new CurrExperiment($display_id);
        }
    }
    else {
        $experiments = Db::getInstance()->getCurrentRunningExperimentIDsPubliclyVisible();
        if(count($experiments) > 0) {
            if(empty($display_id) || !in_array($display_id,$experiments) ) {
                 $exp = new CurrExperiment($experiments[0]);
            }
            else {
                 $exp = new CurrExperiment($display_id);
            }
        }
        else {
            echo "<strong><font size='3'>A non-public Experiment is running on the Testbed</font></strong>\n";
            exit;
        }
    }
}  // the experiments array is empty!
else {
    echo "<br/>\n";
    echo "<strong><font size='3'>No Experiment is running on the Testbed right now!</font></strong>\n";
    echo "<br/>\n";
    echo "<br/>\n";
    
    // this causes the site to be refreshed!
    echo "<div id='no_running_experiment'></div>\n";
    $experiments = Db::getInstance()->getNextExperiments();
    if(count($experiments) > 0) {
        echo "<br/>\n";
        echo "<br/>\n";
        echo "<br/>\n";
        echo "<strong><font size='3'>Next Upcoming Scheduled Experiment:</font></strong>\n";
        echo "<br/>\n";
        echo "<br/>\n";
        foreach($experiments as $exp) {
            displayExperimentBox(getExperimentAsObject($exp), 0, $quick_encrypt_password, $isTestbedMaintainer);
        }
    }
    echo "</div>\n";
    echo "</div>\n";
    echo "</div>\n";    
    echo "</body>\n";
    echo "</html>\n";
    exit;
}

$refreshOutput = 1;

if(!checkAccessRights($_SERVER['personUniqueID'], "viewNetwork"))
{
    echo "<p><font color='#FF000'>" . "<strong>Error:</strong> You are not allowed to view experiments on the testbed!" . "</font></p>";
    exit;
}

else if($exp->visibility == 0 && strcmp($exp->userGroup, $_SERVER['personUniqueID']) != 0 && !$isTestbedMaintainer)
{
    echo "<strong><font size='3'>A non-public Experiment is running on the Testbed</font></strong>";
    exit;
}
else
{
    echo "<br/>\n";
    echo "<br/>\n";
    echo "<strong><font size='3'>Displayed Experiment:</font></strong>\n";
    echo "<br/>\n";
    echo "<br/>\n";
    displayExperimentBox($exp, 1, $quick_encrypt_password, $isTestbedMaintainer);
}
?>
</div>

<div id='expObservControlOutput' class='expObservControlOutput'>
<?php
    echo "<strong>Experiment Control Output:</strong>\n";
    echo "<br/>\n";        
    echo "<br/>\n";
?>
<div id='expObservControlOutputBox' class='expObservControlOutputBox'>
<?php
    echo $exp->getExpControlOutput($exp->expID);
?>

</div>
</div>


<div id='expObservCrossLine' class='crossLine'>&nbsp;</div>

</div>

<div id='expObservContentBox' class='contentBox'>
<div id='expObservNetGraph' class='netGraphSmall' <?php echo "style='background-image:url(" . $config['MAP_PATH'] . "/" . $config['MAP_FILE_NAME']. ");background-repeat:no-repeat;padding-right:10pt;'";?> >

<?php
    $graphWSN = new NetworkGraph($exp->network->name, $exp->network);
    $graphWSN->drawGraph();
    $graphFormat = "svg";
    $graphFile = "./" . $exp->network->name . "Graph." . $graphFormat;

    if (!file_exists($graphFile)) {
            echo "<strong>GraphViz ERROR! The file " .  $graphFile . " does not exist</strong>";
    } 
    $graphFilePrefix = "./" . $exp->network->name . "Graph";
    $command = "mogrify -format png -transparent white " . $graphFilePrefix . ".svg";
      
    exec($command);
    
    echo "<img src='" . $graphFilePrefix . ".png'>";
?>
<script language='javascript'>
    var refreshInterval = <?php echo $config['MAP_REFRESH_INTERVAL']?>;
    //refreshInterval = -1;
    var sendReq = <?php echo $refreshOutput; ?>;
    var displayid = <?php echo "'" . $exp->expID . "'"; ?>;
    displayid = displayid.toString();
    refreshDiv("../ExperimentObservation/expObservGraphData.php?display_id=" + displayid, "divID=expObservNetGraph", refreshInterval, 0, sendReq);
</script></div>

<div id='netObservSNOutputAndCmdBox' class='netObservSNOutputAndCmdBox'>
<?php
    $divIDsStr = "";        //used for the JS refresh function
    $exp->getSensorNodesOutputFromDB(); //get SN output for the initial
    //builds the div containers and forms for the
    // output box and the command input box    
    // only show command line when experiment owner
    if(strcmp($exp->userGroup, $_SERVER['personUniqueID']) == 0) {
        echo "<div id='netObservAllSNResetAndCmd_" . "all" . "' class='netObservAllSNResetAndCmd'>\n";
        echo "<table style='border: 0px solid black' cellspacing='0' width='100%'>\n";
        echo "<tr>";
        echo "<td bgcolor='#F2F2F2' width='51%'><strong>broadcast to all nodes:</strong></td>";
        echo "<td bgcolor='#F2F2F2' width='24%'>";
        echo "<form action='expObservSendCmd.php'" . " method='post' name='netObservSNCmdForm_" .  "all" . "' style='margin:0;' " . " onsubmit=\"return ajaxPost(this.action, getFormData(this),'snCmd_" . "all" . "');\">\n";
            // only show Reset button if experiment owner
        if ( strcmp($exp->userGroup, $_SERVER['personUniqueID']) == 0) {
             echo "<input type='submit' name='resetSN' value='Reset'></input>\n";
        }
        echo "<td bgcolor='#F2F2F2' width='25%' align='right'>";
        echo "<strong>toggle all nodes output:</strong>";
        if(empty($_POST) || $_POST['diplay_all_sn_outputs'] == 'all') {
             echo "<input type='checkbox' name='diplay_all_sn_outputs' value='" . "all" . "' onChange='Javascript:refreshSNAllOutputForm.submit()'></input>\n";
        }
        else {
             echo "<input type='checkbox' name='diplay_all_sn_outputs' value='" . "all" . "' onChange='Javascript:refreshSNAllOutputForm.submit()'></input>\n";
        }
        echo "</td>";
        
        foreach($exp->network->sensornodes as $key => $sn) {
             echo "<input type='hidden' id='snIDs' name='snIDs[]' value='" . $sn->id . "'></input>\n";
        }
        echo "<input type='hidden' id='resetNode' name='resetNode' value='yes'></input>\n";
        echo "<input type='hidden' id='divID' name='divID' value='snCmd_" . "all" . "'></input>\n";    //id of the input box, to clear them after sending
        echo "</form>\n"; //end form resetSN_all
        echo "</td>\n";
        echo "</tr>\n";
        echo "</table>\n";
    
        echo "<form style='background-color:white' action='expObservSendCmd.php'" . " method='post' name='netObservSNCmdForm_" .  "all" . "'" . " onsubmit=\"return ajaxPost(this.action, getFormData(this), 'snCmd_" . "all" . "');\">\n";
        echo "<div style='background-color:white' id='netObservSNAllCmdBox_" . "all" . "' class='netObservSNAllCmdBox'>\n";
        foreach($exp->network->sensornodes as $key => $sn)
        {
             echo "<input type='hidden' id='snIDs' name='snIDs[]' value='" . $sn->id . "'></input>\n";
        }
        echo "<input type='hidden' id='divID' name='divID' value='snCmd_" . "all" . "'></input>\n";    //id of the input box, to clear them after sending
        echo "<input type='text' id='snCmd_" . "all" . "' name='snCmd' style=\"width:99%;\" ></input>\n";
        echo "</div>\n";  //end div netObservSNCmdBox_all
        echo "</form>\n"; // end form netObservSNCmdForm_all
        echo "<br/>";
    
        echo "<form action='' name='refreshSNAllOutputForm' method='POST' style='margin:0;'>";
        echo "<table style='border: 0px solid black' cellspacing='0' width='100%'>";
        echo "<tr>";
    
        echo "</tr>";
        echo "</table>";
        
        foreach($exp->network->sensornodes as $key => $sn) {                
              $divide = explode(":", $sn->id);  //splits the urn (UBERN:xx)
              $divID = $divide[sizeof($divide)-1];              // and takes just the last value
              if(empty($_POST)  || $_POST['diplay_all_sn_outputs'] == 'all') {
                    echo "<input type='hidden' name='checked[" . $divID. "]' value='no'></input>\n";
              }
              else {
                    echo "<input type='hidden' name='checked[" . $divID. "]' value='yes'></input>\n";
              }
        }
        echo "</form>\n"; //end form diplayOutput_all
        echo "</div>\n";  //end div netObservSNOutputAndCmd_all
    }

    foreach($exp->network->sensornodes as $key => $sn)
    {
        $divide = explode(":", $sn->id);  //splits the urn (UBERN:xx)
        $divID = $divide[sizeof($divide)-1];              // and takes just the last value
        $snURN = $sn->id;
        $showMe = 1;
        echo "<div id='netObservSNOutputAndCmd_" . $divID . "' class='netObservSNOutputAndCmd'>\n";
        echo "<table style='border: 0px solid black' cellspacing='0'>\n";
        echo "<colgroup>";
        echo "<col width='80'></col>";
        echo "<col width='355'></col>";
        echo "</colgroup>";
        echo "<tr>";
        echo "<td bgcolor='#F2F2F2'><strong>Node ID:</strong></td>";
        echo "<td bgcolor='#F2F2F2' align='right'><strong>" . $snURN . "</strong></td>";
        echo "</tr>\n";
        echo "</table>\n";
        
        echo "<table style='border: 0px solid black'>\n";
        echo "<colgroup>";
        echo "<col width='368'></col>";
        echo "<col width='50'></col>";
        echo "</colgroup>";
        echo "<tr>";
        echo "<td>";
        echo "<form action='' name='refreshSN" . $divID . "OutputForm' method='POST' style='margin:0;'>\n";
        //fill the hidden fields with the checked (or unchecked) checkboxes of all command output boxes
        // because we have one form for each box (and not one form fior all boxes
        if(!empty($_POST['checked'])) {
             foreach($_POST['checked'] as $snid => $val) {
                  echo "<input type='hidden' id='chk' name='checked[" . $snid. "]' value='" . $val . "'>\n";
                  if(strcmp($val, "yes") == 0)
                  {
                         if($snid == $key)
                         {
                                $divIDsStr = $divIDsStr . $snid . ":";
                         }
                  }
                  if(strcmp($snid, $divID) == 0 && strcmp($val, "no") == 0)
                  {
                         $showMe = 0;
                  }
             }
             }
             else
             {
                  foreach($exp->network->sensornodes as $key1 => $snode)
                  {
                        $pieces = explode(":", $snode->id);                //splits the urn (UBERN:xx)
                        $div_id = $pieces[sizeof($pieces)-1];               // and takes just the last value
                        echo "<input type='hidden' name='checked[" . $div_id. "]' value='yes'></input>";
                        if($key == $key1)
                        {
                                $divIDsStr = $divIDsStr . $div_id . ":";
                        }
                  }
             }

             if(strcmp($_POST['checked'][$divID], "yes") == 0 || empty($_POST) || !empty($_POST['resetSN'])) {
                  echo "<strong>output</strong> <input type='checkbox' name='refresh_sn_output' value='" . $divID . "' onChange='Javascript:refreshSN" . $divID . "OutputForm.submit()'></input>\n";
                  //echo "<strong>output</strong> <input type='checkbox' name='refresh_sn_output' value='" . $divID . "' checked>";
                  echo "<input type='hidden' id='checked' name='checked[" . $divID. "]' value='no'></input>";
             }
             else
             {
                  echo "<strong>output</strong> <input type='checkbox' name='refresh_sn_output' value='" . $divID . "' onChange='Javascript:refreshSN" . $divID . "OutputForm.submit()'></input>\n";
                  echo "<input type='hidden' name='checked[" . $divID. "]' value='yes'>\n";
             }
             echo "</form>\n"; //end form refresSN_xy_OutputForm
             echo "</td>\n"; //end form refresSN_xy_OutputForm
           
             echo "<td><form action='expObservSendCmd.php'" . " method='post' name='netObservSNCmdForm_" .  $divID . "' style='margin:0;'" . " onsubmit=\"return ajaxPost(this.action, getFormData(this),'snCmd_" . $divID . "');\">";
             // only show Reset button if experiment owner
             if ( strcmp($exp->userGroup, $_SERVER['personUniqueID']) == 0 )
             {
                  echo "<input type='submit' name='resetSN' value='Reset'></input>\n";
             }
             echo "<input type='hidden' id='snID' name='snID' value='" . $snURN . "'></input>\n";
             echo "<input type='hidden' id='resetNode' name='resetNode' value='yes'></input>\n";
             echo "<input type='hidden' id='divID' name='divID' value='snCmd_" . $divID . "'></input>\n";    //id of the input box, to clear them after sending
             echo "</form></td>\n"; //end form resetSN_xy_
             echo "</tr>";
             echo "</table>\n";


             echo "<table style='background-color:white; border: 0px solid black'>\n";
             echo "<colgroup>\n";
             echo "<col width='200'></col>\n";
             echo "</colgroup>\n";
             echo "<tr><td>\n";

             if($showMe == 1)
             {
                  echo "<div id='" . $divID . "' class='netObservSNOutputBox'>";
                  echo $sn->output;
                  echo "</div>";  //end div XY
                  echo "</td></tr>\n";
             }
             else
             {
                  echo "<div id='" . $divID . "' class='netObservSNOutputBoxSmall'>";
                  echo "</div>";  //end div XY
                  echo "</td></tr>\n";
             }           
             // only show command line when experiment owner
             if($showMe == 1 && strcmp($exp->userGroup, $_SERVER['personUniqueID']) == 0 )
             {
                  echo "<tr><td>\n";
                  echo "<form style='background-color:white' action='expObservSendCmd.php'" . " method='post' name='netObservSNCmdForm_" .  $divID . "'" . " onsubmit=\"return ajaxPost(this.action, getFormData(this),'snCmd_" . $divID . "');\">\n";
                  echo "<div style='background-color:white' id='netObservSNCmdBox_" . $divID . "' class='netObservSNCmdBox'>\n";
                  echo "<input type='hidden' id='snID' name='snID' value='" . $snURN . "'></input>\n";
                  echo "<input type='hidden' id='divID' name='divID' value='snCmd_" . $divID . "'></input>\n";    //id of the input box, to clear them after sending
                  echo "<input type='text' id='snCmd_" . $divID . "' name='snCmd' style=\"width:99%;\" ></input>\n";
                  // echo "<input type='image' src='../pics/fakeButton.gif' id='snCmdSubmit' name='snCmdSubmit'>";
                  echo "</div>\n";  //end div netObservSNCmdBox_snXY
                  echo "</form>\n"; // end form netObservSNCmdForm_snXY
             }
             echo "</td></tr>\n";
             echo "</table>\n";
             echo "</div>\n"; // end div netObservSNOutputAndCmd_snXY
             
    } // foreach loop for each node
    
    $divIDsStr = "divID=" . substr($divIDsStr, 0, strlen($divIDsStr) - 1);
?> 

<script language='javascript'>
    var divIDstr = unescape("<?php echo rawurlencode($divIDsStr); ?>");
    scrollDown(divIDstr);
    var sendReq = <?php echo $refreshOutput; ?>;
    var displayid = <?php echo "'" . $exp->expID . "'"; ?>;
    displayid = displayid.toString();
    refreshDivs("../ExperimentObservation/expObservSNOutputData.php?display_id=" + displayid, divIDstr, 1000, sendReq);
</script>
</div>
</div>

</div>
</body>
</html>
