<?php
  function iso8601($time=false) {
    if(!$time) $time=time();
    return date("Y-m-d", $time) . 'T' . date("H:i:s", $time) .'+00:00';
  }
  
  function replaceChars($name) {
       $name = str_replace(" ", "_", $name);
       $name = str_replace(".", "_", $name);
       $name = str_replace("&", "_", $name);
       return $name;
  }


  require_once('../include/configurations.php');
  require_once("../include/classes.inc.php");
  //select DB
  Db::getInstance($config)->selectDB();
	  
  if(!empty($_POST))
  {
    if($_POST['download'] == "Download")
    {
      $expID = $_POST['exp_id'];
      $experiments = Db::getInstance($config)->getOldExperimentConfigurations($expID);
      $exp = $experiments[$expID];
      $startTime = $exp['exp_start_time'];
      $endTime = $exp['exp_end_time'];
      $name = trim($exp['exp_name']);
      
      $startTime = replaceChars($startTime);
      $endTime   = replaceChars($endTime);
      
      $expFilename = "experiment#("; 
      if(strlen($name) < 200) {
          $name = replaceChars($name);
          $expFilename = $expFilename . "name=" . $name . ",";
      }
      $expFilename = $expFilename . "id=".$expID.",start=".$startTime.",end=".$endTime.").zip";
      //echo "expfilename: ". $expFilename;
      
      header("Content-type: application/zip");
      header("Content-Disposition: attachment; filename=$expFilename");
      echo $exp['exp_result'];
    }
  }
?>
