function js_clock()
{
  var clock_time = new Date();
  var clock_hours = clock_time.getUTCHours();
  var clock_minutes = clock_time.getUTCMinutes();
  var clock_seconds = clock_time.getUTCSeconds();
  var clock_year = clock_time.getUTCFullYear();
  var clock_month = clock_time.getUTCMonth() + 1;
  var clock_date = clock_time.getUTCDate();				

  if (clock_hours < 10)
  {
	  clock_hours = "0" + clock_hours;
	}

  if (clock_minutes < 10)
  {
    clock_minutes = "0" + clock_minutes;
  }

	if (clock_seconds < 10)
	{
    clock_seconds = "0" + clock_seconds;
	}

  if (clock_month < 10)
  {
    clock_month = "0" + clock_month;
  }

  if (clock_date < 10)
  {
    clock_date = "0" + clock_date;
  }

  var clock_div = document.getElementById('utcClock');
  clock_div.innerHTML = "<b>" + clock_year + "-" + clock_month + "-" + clock_date + " " + clock_hours + ":" + clock_minutes + ":" + clock_seconds + " UTC</b>";
  setTimeout("js_clock()", 1000);
}


  function toggleUpload(){
    if(document.getElementById('upload').style.display == 'none'){
      document.getElementById('upload').style.display = 'block';
    }else{
      document.getElementById('upload').style.display = 'none';
    }
  }

//=============================================================================
//=============================================================================

            			
function alerttest()
{
  alert("alert test");
}


//=============================================================================
//=============================================================================


//returns the string with the comma-seperated IDs of the selected nodes
function getIDsFromSelectedNodes()
{
 	var selectedNodesStr = tree.getAllChecked();
  var selectedNodesList = selectedNodesStr.split(",");
  var resultString = "";
    	
 	for (var i = 0; i < selectedNodesList.length; i++)
 	{
   	if(selectedNodesList[i] != "network")
   	{
   	  var snIdId = selectedNodesList[i] + "_ID";
   	  var snID = (tree.getItemText(snIdId)).split(": ");
   	  if(i < selectedNodesList.length - 1)  //first elements of the list
   	  {
   	    resultString = resultString + snID[1] + ",";
 	    }
 	    else                                  //last elemet of the list
 	    {
   	    resultString = resultString + snID[1];
 	    }
    }
 	}
 	return resultString;
}


//=============================================================================
//=============================================================================


//converts the elements of the form (post-data into a js array  
function getFormData(form, asArray)
{
	var ret;

	var add = function(n, v)
	{
		if(asArray)
		{
			if(ret == null) ret = new Array();
			ret[n] = escape(v);
		}
		else
		{
			ret = (ret == null ? '' : ret+'&') + n +'='+ escape(v);
		}
	};

	for(var i=0; i<form.elements.length; i++)
	{
		var el = form.elements[i];

		var type = (el.type || '');

		if(type.match(/^(text|hidden|textarea)$/i) || (type.match(/^(radio|checkbox)$/i) && el.checked))
		{
			add(el.name, el.value);
		}
		else if(el.nodeName.match(/^select$/i))
		{
    	for(var j=0; j<el.options.length; j++)
    	{
				if(el.options[j].selected)
				{
					add(el.name, el.options[j].value);
				}
			}
		}
		else if(el.nodeName.match(/^textarea$/i))
		{
			add(el.name, el.value);
		}
	}
	return ret != null ? ret : (asArray ? new Array() : '');
} 


//=============================================================================
//=============================================================================


function ajaxPost(url, postData, callback)
{
  var req;
 	try
  {
    req = window.XMLHttpRequest ? new XMLHttpRequest(): new ActiveXObject("Microsoft.XMLHTTP"); 
  }
  catch (e)
  {
	 	// browser does not have ajax support
  }
	req.onreadystatechange = typeof callback == 'function' ? callback : function()
  {
	 	if (req.readyState == 4 && req.status == 200)
	  {
		  if(typeof callback == 'string') 
  		{
	 		  callback = document.getElementById(callback);
	    }
		  if(callback)
  		{
  	  	var cmdInputbox = document.getElementById(req.responseText);
   			cmdInputbox.value = "";
	  	}
  	}
	};
  req.open('POST', url, true);
	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
  req.send(postData);
  return false;
}

//=============================================================================
//=============================================================================


function ajaxPost2(url, postData, callback)
{
  var req;
 	try
  {
    req = window.XMLHttpRequest ? new XMLHttpRequest(): new ActiveXObject("Microsoft.XMLHTTP"); 
  }
  catch (e)
  {
	 	// browser does not have ajax support
  }
	req.onreadystatechange = typeof callback == 'function' ? callback : function()
  {
	 	if (req.readyState == 4 && req.status == 200)
	  {
		  if(typeof callback == 'string') 
  		{
	 		  callback = document.getElementById(callback);
	    }
		  if(callback)
  		{
  	  	var cmdInputbox = document.getElementById(req.responseText);
   			cmdInputbox.value = "";
	  	}
  	}
	};
  req.open('POST', url, true);
	req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
  req.send(postData);
  return false;
}

//=============================================================================
//=============================================================================


//scrollDown:
//  - called from windows.onload of expOberservIndex.php
//  - expects the div ids as array
//  - gets the divObject by the ID string
//  - scrolls the scroll bar to down
function scrollDown(divIDsStr)
{
  var splitStr = divIDsStr.split("=");
  var divIDs = splitStr[1].split(":")
  for(i = 0; i < divIDs.length; i++)
  {
    var divObject = document.getElementById(divIDs[i]);
	  divObject.scrollTop = divObject.scrollHeight;
 }
} 


//=============================================================================
//=============================================================================


//myXMLHttpRequest:
//  - creates and returns the request
//  - called by refreshDiv()
function myXMLHttpRequest()
{
  var xmlhttplocal;
  try
  {
  	xmlhttplocal = new ActiveXObject ("Msxml2.XMLHTTP")
  }
  catch(e)
  {
	  try
	  {
	    xmlhttplocal = new ActiveXObject ("Microsoft.XMLHTTP")
	  }
	  catch(E)
	  {
	    xmlhttplocal = false;
	  }
  }

  if(!xmlhttplocal && typeof XMLHttpRequest != 'undefined')
  {
	  try
	  {
	    var xmlhttplocal = new XMLHttpRequest();
	  }
	  catch (e)
	  {
	    var xmlhttplocal = false;
	  }
  }
  return (xmlhttplocal);
}


//=============================================================================
//=============================================================================


//refreshDiv:
//  - gets the url (e.g. php-script), a string to send to the url (e.g. the
//    divID which should be refreshed) and the interval to refresh
//  - builds the request, sends the string to the url
//  - takes the response string (which has a certain format), excludes the
//    divID and fills the div
//  - set timout to recall the function recursively
//  - called by expObservIndex.php
function refreshDiv(url, sendStr, refreshInterval, firstcall, sendReq)
{
  if(sendReq != 0)
  {
   	xmlhttpreq = new myXMLHttpRequest();
	  if(xmlhttpreq)
  	{
      xmlhttpreq.open("POST", url, true);
      xmlhttpreq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      xmlhttpreq.send(sendStr);     //send string to the url/php script ($_POST)
      xmlhttpreq.onreadystatechange = function()
      {
        if(xmlhttpreq.readyState == 4)
        {
          responseStr = xmlhttpreq.responseText;    //format: divID==>xyz:::divContent==>abcd
          var splitStr = responseStr.split(":::");  //split into divID and divContent
          var divID = splitStr[0].split("==>");     //take the divID
          var divContent = splitStr[1].split("==>");//take the divContent
          targetDiv = document.getElementById(divID[1]);
          targetDiv.innerHTML = divContent[1];
        }
      }
    }
    if(firstcall == 0)
    {
      setTimeout(function(){refreshDiv(url, sendStr, refreshInterval, 1);}, 100); //because the function refreshDiv has parameters
    }
    else
    {
      setTimeout(function(){refreshDiv(url, sendStr, refreshInterval, 1);}, refreshInterval); //because the function refreshDiv has parameters
    }
  }
}


//=============================================================================
//=============================================================================


//refreshDivs:
//  - gets the url (e.g. php-script), a string to send to the url (e.g. the
//    divID which should be refreshed) and the interval to refresh
//  - builds the request, sends the string to the url
//  - takes the response string (which has a certain format), excludes the
//    divID and fills the div
//  - set timout to recall the function recursively
//  - called by expObservIndex.php
function refreshDivs(url, sendStr, refreshInterval, sendReq)
{
  if(sendReq != 0)
  {
   	xmlhttpreq = new myXMLHttpRequest();
	if(xmlhttpreq)
  	{
      xmlhttpreq.open("POST", url, true);
      xmlhttpreq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      xmlhttpreq.send(sendStr);     //send string to the url/php script ($_POST)
      xmlhttpreq.onreadystatechange = function()
      {
        if(xmlhttpreq.readyState == 4)
        {
          responseStr = xmlhttpreq.responseText;    //format: divID==>xyz:::divContent==>abcd
          var splitDivs = responseStr.split("|||");  //split into divs
          var splitDivsLen = splitDivs.length;
          for(i = 0; i < splitDivs.length; i++)
          {
            var splitStr = splitDivs[i].split(":::");  //split into divID and divContent
            var divID = splitStr[0].split("==>");     //take the divID
            var divContent = splitStr[1].split("==>");//take the divContent
            targetDiv = document.getElementById(divID[1]);
            targetDiv.innerHTML = divContent[1];
            targetDiv.scrollTop = targetDiv.scrollHeight;
          }
        }
      }
    }
    setTimeout(function(){refreshDivs(url, sendStr, refreshInterval, 1);}, refreshInterval); //because the function refreshDiv has parameters
  }
}



