<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
 * Copyright (C) 2004  SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: WebCTAPI.inc,v 1.2 2004/10/06 14:51:52 vlry Exp $
 */

/**
* This is the common include file for the WebCTCEAPI package. 
* Include (use require_once, not require or include) this file at the 
* beginning of your PHP page in order to load the required constants, 
* classes, and libraries.
*
* <b>Example</b>
* <pre>
*   // load the WebCTCEAPI package
*   //
*   require_once("include/webct/WebCTAPI.inc");
* </pre>
*
* @version $Revision: 1.2 $
* @author Valery Tschopp - SWITCH
* @package WebCTAPI 
*/

require_once("include/webct/WebCTAPI_Constants.inc");
require_once("include/webct/WebCTAPI_Request.class.inc");
?>
