<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
 * Copyright (C) 2004  SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: WebCTAPI_Constants.inc,v 1.5 2006/11/30 17:01:44 vlry Exp $
 */

/**
* Constant definitions for the WebCT CE API.
*
* @version $Revision: 1.5 $
* @author Valery Tschopp - SWITCH
* @package WebCTAPI 
*/

/*
 * Define used POST requst parameter names.
 */
define('WEBCTCE_API_PARAM_OPERATION',   'OPERATION');
define('WEBCTCE_API_PARAM_DB',          'DB');
define('WEBCTCE_API_PARAM_COURSE',      'COURSE');
define('WEBCTCE_API_PARAM_AUTH',        'AUTH');
define('WEBCTCE_API_PARAM_USERID',      'User ID');
define('WEBCTCE_API_PARAM_PASSWORD',    'Password');
define('WEBCTCE_API_PARAM_WEBCTID',     'WebCT ID');
define('WEBCTCE_API_PARAM_IMSID',       'IMS ID');
define('WEBCTCE_API_PARAM_USERTYPE',    'USER_TYPE');
define('WEBCTCE_API_PARAM_ENCRYPTED',   'ENCRYPTED');
define('WEBCTCE_API_PARAM_CHARSET',     'CHARSET');

/*
 * Define possible request values for OPERATION=
 */
define('WEBCTCE_API_OPERATION_FIND',    'find');
define('WEBCTCE_API_OPERATION_UPDATE',  'update');
define('WEBCTCE_API_OPERATION_ADD',     'add');

/*
 * Define possible values for DB=
 */
define('WEBCTCE_API_DB_GLOBAL',         'global');
define('WEBCTCE_API_DB_STUDENT',        'student');

/*
 * Define possible values for COURSE=
 */
define('WEBCTCE_API_COURSE_PLACEHOLDER','XXXXXXX');

/*
 * Define possible values for USERTYPE=
 */
define('WEBCTCE_API_USERTYPE_DISABLE',  '0');
define('WEBCTCE_API_USERTYPE_ENABLE',   '1');

/*
 *
 */
define('WEBCTCE_API_ENCRYPTED_DISABLE', '0');
define('WEBCTCE_API_ENCRYPTED_ENABLE',  '1');
/*
 * Define possible Field names
 */
define('WEBCTCE_API_FIELD_FIRSTNAME',         'First Name');
define('WEBCTCE_API_FIELD_LASTNAME',          'Last Name');
define('WEBCTCE_API_FIELD_COURSES',           'Courses');
define('WEBCTCE_API_FIELD_REGISTEREDCOURSES', 'Registered Courses');
?>
