#!/usr/bin/ruby -w


def parse_config(config) file = File.open(config,'r')
    a_hash = {}
    file.each_line do |line|
      if (line.lstrip).index('#') == 0
        next
      end 
      if line.lstrip.rstrip.eql? ""
        next
      end 
      if line.include?('=')
        key, value = line.split('=')
        valueBefore, valueAfter = value.split('#')
        # puts "value: " + value
        # puts "valueBefore: " + valueBefore
        # if !valueAfter.nil?
        # puts "valueAfter: " + valueAfter
        # end
        a_hash[key] = valueBefore
      end 
    end 
    file.close
  return a_hash

end


def getIDFromURN(urn)
  array = urn.split(/:/)
  return array[array.size()-1]
end

def getPrefixFromURN(urn)
  array = urn.split(/:/)
  string=""
  (array.length-1).times do |i|
    string = string + array[i].to_s() + ":"
  end
  return string
end

def isint(str)
   return str =~ /^[-+]?[0-9]+$/
end


def getUTCTimeString
  time = Time.now.utc
  timeString = time.strftime("%Y-%m-%d %H:%M:%S")
  return timeString
end

def getMinutes
  time = Time.new
  return time.min
end

def getUsecs
  time = Time.new
  return time.usec
end

