<?php 
  require_once('../include/classes.inc.php');

  $divIDs = explode(':', $_POST['divID']);
  $divID = $divIDs[0];              //extract the div id (which is send by refresDiv)
  
  $display_id = $_GET['display_id'];
  
  $responseStr = "divID==>" . $divID . ":::";
  
  Db::getInstance()->selectDB("wsn_info");
  $experiments = Db::getInstance()->getCurrentRunningExperimentIDs();
  
  $exp = new CurrExperiment($display_id);      //build experiment network object
  if(!empty($exp->expID))           //if there is an experiment
  {
    $graphWSN = new NetworkGraph($exp->network->name, $exp->network); //build network graph object
    $graphWSN->drawGraph();         //create the svg file
    $graphFormat = "svg";
    $graphFile = "./" . $exp->network->name . "Graph." . $graphFormat;
 
    if (!file_exists($graphFile)) {
            echo "<strong>GraphViz ERROR! The file " .  $graphFile . " does not exist</strong>";
    } 
    $graphFilePrefix = "./" . $exp->network->name . "Graph";
    $command = "mogrify -format png -transparent white " . $graphFilePrefix . ".svg";
      
    exec($command);
    
  	$contentStr = "divContent==>" . "<img src='" . $graphFilePrefix . ".png'></img>";
  }
  else                              //if there is no experiment
  {
    $contentStr = "divContent==>" . "";
  }
  
  $responseStr = $responseStr . $contentStr;
  echo $responseStr;                // echo the response string which is used by refreshDiv
?>