<?php
/* ****************************************************************** 
 * index.php  - the AAI start page with the selection of login
 *   approaches 
 *
 * Version:
 *   $Id: admin.php,v 1.13 2006/04/07 08:25:04 vlry Exp $
 *
 * *****************************************************************
 * RVS (http://www.iam.unibe.ch/~rvs/)  (c) 2003 
 * ******************************************************************
 */

require_once("include/application.inc");
require_once("lookandfeel/current/lf-specific-functions.inc");
?>
<html>
<head>
<title>SNAportal Login</title>
<link rel="stylesheet" href="<?= lf_get_user_style_sheet_url() ?>" type="text/css">

<style type="text/css">
<!--
    /* WISEBEDaai Login pages style */
    a.wisebedaai-link {
        font-family: Verdana, Arial, Helvetica, sans-serif; 
        color: #203781; 
        font-size: 12;
    }
    .wisebedaai-link { 
        font-family: Verdana, Arial, Helvetica, sans-serif; 
        color: #203781; 
        font-size: 12; 
    }
    img.wisebedaai-login-button {
        padding-bottom: 10; 
        padding-top: 12;
    }
    img.non-aai-login-button {
        padding-bottom: 8; 
        padding-top: 40;
    }
    input.non-aai-login-button {
        padding-bottom: 8; 
        padding-top: 12; 
        float: right;
    }
    .fullheight {
      height: 100%; 
      min-height: 100%;
    }
    
    /* boxing styles */
    td.wisebedaai {
      font-family: Verdana, Arial, Helvetica, sans-serif; 
      background: #FFFFFF; 
      color: #000000; 
      font-size: 12;
    }
    td.top-left-x {
        background-image: url('lookandfeel/current/obenlinksx.gif');
        height: 14px;
        width: 14px;
    }
    td.top-middle-x {
        background-image: url('lookandfeel/current/obenmittex.gif');
        height: 14px;
    }
    td.top-right-x {
        background-image: url('lookandfeel/current/obenrechtsx.gif');
        height: 14px;
        width: 14px;
    }
    td.middle-left-x {
        background-image: url('lookandfeel/current/mittelinksx.gif');
        width: 14px;
    }
    td.middle-right-x {
        background-image: url('lookandfeel/current/mitterechtsx.gif');
        width: 14px;
    }
    td.bottom-left-x {
        background-image: url('lookandfeel/current/untenlinksx.gif');
        height: 14px;
        width: 14px;
    }
    td.bottom-middle-x {
        background-image: url('lookandfeel/current/untenmittex.gif');
        height: 14px;
    }
    td.bottom-right-x {
        background-image: url('lookandfeel/current/untenrechtsx.gif');
        height: 14px;
        width: 14px;
    }
-->
</style>

</head>
<body>

<p class="welcome-title" style="padding-top: 1cm; text-align: center;">
Welcome to the SNAportal (<?= SNA_PORTAL_VERSION ?>)
<noscript>
<br><strong style="color: red;">You must enable JavaScript otherwise administrator functionalities will not work</strong>
</noscript>
</p>

<div align="center">
<table width="50%" class="data-table">

<tr>
  <th width="33%" class="data">
  <strong>Login as Administrator</strong>
  </td>
</tr>
<tr>
   <td class="data-even" valign="top" align="center" style="padding-top: 0.5cm; padding-bottom: 0.5cm;">


<!-- WISEBEDaai Login -->
  <table class="wisebedaai" border="0" cellpadding="0" cellspacing="0" width="60%">
    <tr>
      <td width="14"><img name="obenlinks" src="lookandfeel/current/obenlinks.gif" width="14" height="14" border="0" alt=""></td>
      <td><img name="obenmitte" src="lookandfeel/current/obenmitte.gif" width="100%" height="14" border="0" alt=""></td>
      <td width="14"><img name="obenrechts" src="lookandfeel/current/obenrechts.gif" width="14" height="14" border="0" alt=""></td>
    </tr>
    <tr>
      <td rowspan="3" class="fullheight"><img name="mittelinks" src="lookandfeel/current/mittelinks.gif" width="14" height="100%" border="0" alt=""></td>
      <td class="wisebedaai"><img src="lookandfeel/current/wisebed-logo.png" height="96"></td>
      <td rowspan="3" style="height: 100%"><img name="mitterechts" src="lookandfeel/current/mitterechts.gif" width="14" height="100%" border="0" alt=""></td>
    </tr>
    <tr><td class="wisebedaai" height="30"></td></tr>
    <tr>
      <td valign="top" class="wisebedaai">
        <p><b>AAI Login for Administrator</b></p>
        <p>Available to the members of the institutions participating in the <a href="http://www.switch.ch/aai/participants/" target="wisebedaai">WISEBED Federation</a> which are SNAportal administrators.
    <a href="admin/aai/login.php"><img src="lookandfeel/current/button-login.gif"  height="24" border="0" alt="login" class="wisebedaai-login-button" align="right"></a></p>
      </td>
    </tr>
    <tr>
      <td><img name="untenlinks" src="lookandfeel/current/untenlinks.gif" width="14" height="14" border="0" alt=""></td>
      <td><img name="untenmitte" src="lookandfeel/current/untenmitte.gif" width="100%" height="14" border="0" alt=""></td>
      <td><img name="untenrechts" src="lookandfeel/current/untenrechts.gif" width="14" height="14" border="0" alt=""></td>
    </tr>
  </table>

<!-- local Login -->

     <p>&nbsp;</p><p/>
     
       <table border="0" cellpadding="0" cellspacing="0" width="60%">
        <tr>
            <td class="top-left-x"></td>
            <td class="top-middle-x"></td>
            <td class="top-right-x"></td>
        </tr>
        <!-- links + content + right -->
        <tr>
          <!-- links border -->
          <td class="middle-left-x"></td>
          <!-- content -->
          <td class="wisebedaai" valign="top">
            <p><b>Login for local administrators</b></p>
            <p>
            <form method="post" action="admin/login.php">
            <input type="hidden" name="do_auth" value="1" />
            <table width="90%">
            <tr>
              <td class="wisebedaai">Username</td>
              <td class="wisebedaai"><input type="text" name="username" size="20" maxlength="30" tabindex="1"></td>
            </tr>
            <tr>
              <td class="wisebedaai">Password</td>
              <td class="wisebedaai"><input type="password" name="password" size="20" maxlength="30" tabindex="2"></td>
            </tr>
            </table>
            <input type="image" src="lookandfeel/current/button-login-gray.gif" width="52" height="19" border="0" class="non-aai-login-button" alt="login" align="bottom">
            </form>
          </td>
          <!-- right border -->
          <td class="middle-right-x"></td>
        </tr>
        <tr>
            <td class="bottom-left-x"></td>
            <td class="bottom-middle-x"></td>
            <td class="bottom-right-x"></td>
        </tr>
      </table>
     
  </td>

</tr>
<tr>
  <th width="33%" class="data">
  <a href="index.php">User Access</a>
  </td>
</tr>

</table>
</div>

</body>
</html>

